module ActiveSchema
  SCHEMAS = {}

  def apply table = nil
    schemas = table ? SCHEMAS.select {|t,_| t == table} : SCHEMAS
    schemas.each_pair do |table, (conn, opts, schema)|
      Schema.new(conn, table, opts, &schema)
    end
  end
  module_function :apply
end

require 'active_schema/api'
require 'active_schema/schema'
require 'active_schema/table'
require 'active_schema/column'
require 'active_schema/index'
