module ActiveSchema
  class Index

    def initialize connection, table_name, columns, opts
      @connection, @table_name, @columns, @opts = \
        connection, table_name, columns, opts

      # nothing to do if index of given columns with given opts already exists
      return if index_exists?(@opts)

      # if index of given columns exists and it has different options, remove it
      remove_index if index_exists?

      add_index
    end

    private

    def index_exists? opts = {}
      @connection.index_exists?(@table_name, @columns, opts)
    end

    def add_index
      @connection.add_index(@table_name, @columns, @opts)
    end

    def remove_index
      # @connection.remove_index(@table_name, column: @columns)
    end

    class Pruner

      def initialize connection, table_name, indexes
        @connection, @table_name, @indexes = \
          connection, table_name, indexes

        existing = @connection.indexes(@table_name).map(&:name)
        specified = @indexes.map {|c| @connection.index_name(@table_name, c)}

        p [existing, specified]

        (existing - specified).each do |index|
          @connection.remove_index(@table_name, index)
        end

      end
    end
  end
end
