module ActiveSchema
  class Table

    def initialize connection, table_name, table_opts, columns
      @connection, @table_name, @table_opts, @columns =
        connection, table_name, table_opts, columns
    end

    def create
      @connection.create_table(@table_name, @table_opts) do |t|
        @columns.each_pair do |name,(type,opts)|
          t.column(name, type, opts)
        end
      end
    end

    def exists?
      @connection.table_exists?(@table_name)
    end
  end
end
